# HG changeset patch
# User yz06
# Date 1456391989 -28800
#      Thu Feb 25 17:19:49 2016 +0800
# Node ID 429ac2c222952cb58451283db685161404587d14
# Parent  f94872f084a1e8ac4eaef8eeede29fdddb31e9ba
APBU11400/SR64026:Add buffer length checking during parsing.

diff -r f94872f084a1 -r 429ac2c22295 gst-plugins-bad/gst/mpegdemux/gstmpegdemux.c
--- a/gst-plugins-bad/gst/mpegdemux/gstmpegdemux.c	Thu Jan 07 16:19:31 2016 +0800
+++ b/gst-plugins-bad/gst/mpegdemux/gstmpegdemux.c	Thu Feb 25 17:19:49 2016 +0800
@@ -2250,7 +2250,7 @@
 }
 
 static inline gboolean
-gst_flups_demux_scan_ts (GstFluPSDemux * demux, const guint8 * data,
+gst_flups_demux_scan_ts (GstFluPSDemux * demux, const guint8 * data, const guint8 * data_end,
     SCAN_MODE mode, guint64 * rts)
 {
   gboolean ret = FALSE;
@@ -2267,6 +2267,8 @@
   /* skip start code */
   data += 4;
 
+  if(data+8 > data_end)
+	  return FALSE;
   scr1 = GST_READ_UINT32_BE (data);
   scr2 = GST_READ_UINT32_BE (data + 4);
 
@@ -2300,6 +2302,8 @@
        to DTS/PTS, that also implies 1 tick rounding error */
     data += 6;
     /* PMR:22 ! :2==11 ! reserved:5 ! stuffing_len:3 */
+    if(data+4 > data_end)
+	  return FALSE;
     next32 = GST_READ_UINT32_BE (data);
     if ((next32 & 0x00000300) != 0x00000300)
       goto beach;
@@ -2332,6 +2336,8 @@
   }
 
   /* read the 4 bytes for the PES sync code */
+  if(data+4 > data_end)
+	  return FALSE;
   code = GST_READ_UINT32_BE (data);
   if (!gst_flups_demux_is_pes_sync (code))
     goto beach;
@@ -2369,10 +2375,14 @@
 
   /* PTS but no DTS, never for mpeg2 */
   if ((*data & 0xf0) == 0x20) {
+    if(data+8 > data_end)
+	  return FALSE;
     READ_TS (data, pts, beach);
   }
   /* PTS and DTS, never for mpeg2 */
   else if ((*data & 0xf0) == 0x30) {
+    if(data+8 > data_end)
+	  return FALSE;
     READ_TS (data, pts, beach);
     READ_TS (data, dts, beach);
   } else if ((*data & 0xc0) == 0x80) {
@@ -2467,7 +2477,8 @@
     end_scan = GST_BUFFER_SIZE (buffer) - scan_sz;
     /* scan the block */
     for (cursor = 0; !found && cursor <= end_scan; cursor++) {
-      found = gst_flups_demux_scan_ts (demux, data++, mode, &ts);
+      found = gst_flups_demux_scan_ts (demux, data, data+scan_sz, mode, &ts);
+	  data++;
     }
 
     /* done with the buffer, unref it */
@@ -2523,7 +2534,8 @@
     data = GST_BUFFER_DATA (buffer) + start_scan;
     /* scan the block */
     for (cursor = (start_scan + 1); !found && cursor > 0; cursor--) {
-      found = gst_flups_demux_scan_ts (demux, data--, mode, &ts);
+      found = gst_flups_demux_scan_ts (demux, data, data+scan_sz, mode, &ts);
+	  data--;
     }
 
     /* done with the buffer, unref it */
